package cr311h3;

import j2d.ImageUtils;
import j2d.ShortImageBean;
import j2d.SpatialCorrelationOld;
import j2d.border.BorderUtils;
import math.Mat2;

import java.awt.*;

import gui.In;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Feb 20, 2006
 * Time: 4:29:28 PM
 */
public class HW5 {
    public static void main(String[] args) {
        hw5();
    }

    public static void hw5() {
        short[][] fivebyfive = Mat2.getSampleSquareMatrix(5);
        Mat2.print(fivebyfive);
        short[][] threebythree = Mat2.getSampleSquareMatrix(3);
        Mat2.print(threebythree);
        ShortImageBean sib5 = new ShortImageBean(fivebyfive, fivebyfive, fivebyfive);
        ShortImageBean sib3 = new ShortImageBean(threebythree, threebythree, threebythree);
        System.out.println("about to perform spatial correlation:");
        ShortImageBean sc = new ShortImageBean(SpatialCorrelationOld.getSpatialCorrelation(
                sib3.getImage(), sib5.getImage()));
        System.out.println("---correlation done!---");
        Mat2.print(sc.getR());
        if (!Mat2.equal(sc.getR(),getSample()))
            In.message("you broke correlation!");
        System.out.println("busted simpleCorrelationOutput");
        short simpleCorrelationOutput[][] = SpatialCorrelationOld.getSpatialCorrelation(threebythree,fivebyfive);
        System.out.println("got spatial correlation between 5x5 and 3x3");
        Mat2.print(simpleCorrelationOutput);
        convolution(sib3, sib5);
        // now suppose you grow the border
        Image grownImage = BorderUtils.getBorderImage(
                sib5.getImage(),
                3, 3, 3, 3, BorderUtils.BORDER_REFLECT);
        convolution(sib3, new ShortImageBean(grownImage));
    }

    public static short[][] getSample() {

        short s[][] = {
                {127, 255, 255, 255, 127},
                {127, 255, 255, 255, 127},
                {127, 255, 255, 255, 127},
                {127, 255, 255, 255, 127},
                {127, 255, 255, 255, 127}
        };
        return s;
    }

    /*
    127 255 255 255 127
    127 255 255 255 127
    127 255 255 255 127
    127 255 255 255 127
    127 255 255 255 127
    */
    private static void convolution(ShortImageBean template, ShortImageBean sib5) {
        float sf = 3;
        float k[][] = Mat2.scale(template.getR(), sf);
        Image convolutionImage = ImageUtils.convolution(sib5.getImage(), k);
        System.out.println("---convolution---");
        Mat2.print(new ShortImageBean(convolutionImage).getR());
    }
}
